'use strict';

var _rollupStream = require('rollup-stream');

var _rollupStream2 = _interopRequireDefault(_rollupStream);

var _vinylSourceStream = require('vinyl-source-stream');

var _vinylSourceStream2 = _interopRequireDefault(_vinylSourceStream);

var _vinylBuffer = require('vinyl-buffer');

var _vinylBuffer2 = _interopRequireDefault(_vinylBuffer);

var _rollup = require('rollup');

var _rollupWatch = require('rollup-watch');

var _rollupWatch2 = _interopRequireDefault(_rollupWatch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 |----------------------------------------------------------------
 | Webpack
 |----------------------------------------------------------------
 |
 | This task will allow you to use ES2015 code in any browser.
 | It leverages Webpack and Buble to transform and compile
 | your code into a single entry point for the browser.
 |
 */

Elixir.extend('rollup', function (scripts, output, baseDir, options) {
    var paths = getPaths(scripts, baseDir, output);

    new Elixir.Task('rollup', function ($) {
        return (0, _rollupStream2.default)({
            entry: this.src.path,
            sourceMap: true
        }).pipe((0, _vinylSourceStream2.default)(this.output.name)).pipe((0, _vinylBuffer2.default)()).pipe(this.initSourceMaps({ loadMaps: true })).pipe(this.writeSourceMaps()).pipe(this.saveAs(gulp));
    }, paths);
    var watcher = (0, _rollupWatch2.default)(_rollup.rollup);
    watcher.on('event', function (event) {
        console.log(event);
    });
});

/**
 * Prep the Gulp src and output paths.
 *
 * @param  {string|Array} src
 * @param  {string|null}  baseDir
 * @param  {string|null}  output
 * @return {GulpPaths}
 */
function getPaths(src, baseDir, output) {
    return new Elixir.GulpPaths().src(src, baseDir || Elixir.config.get('assets.js.folder')).output(output || Elixir.config.get('public.js.outputFolder'), 'all.js');
}